BCU = '192.168.0.64';

MGP_DEFINE();

BCU_LOGIC_FLASH_PROGRAM_FILE = 'BCULogic_12_14.rbf';
DSP_LOGIC_FLASH_PROGRAM_FILE = 'DSPLogic_6_00.rbf';
SG_LOGIC_FLASH_PROGRAM_FILE  = 'SigGenLogic_4_04.rbf';

BCU_NIOS_FLASH_PROGRAM_FILE = 'BCUNios_4_17_0302.bin';
DSP_NIOS_FLASH_PROGRAM_FILE = 'DSPNios_4_00_0001.bin';
SG_NIOS_FLASH_PROGRAM_FILE  = 'DSPNios_3_08_0002.bin';

AOConnect(BCU);
aoGetDSPFirmwareVer(0)

serial_number=input('DSP board serial number (0 to exit): ');
if serial_number==0
   break;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% prima programmazione schede DSP                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
aoProgramFlash(DEFAULT_LOGIC,DSP_LOGIC_FLASH_PROGRAM_FILE,0,0);
aoProgramFlash(DEFAULT_PROGRAM,DSP_NIOS_FLASH_PROGRAM_FILE,0,0);
aoProgramFlash(USER_LOGIC,DSP_LOGIC_FLASH_PROGRAM_FILE,0,0);
aoProgramFlash(USER_PROGRAM,DSP_NIOS_FLASH_PROGRAM_FILE,0,0);
mgp_op_write_flash(0,0,1,'0xfc000',serial_number) % serial number

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% prima programmazione schede SIG-GEN                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% aoProgramFlash(1,RTR_SG_LOGIC_FLASH_PROGRAM_FILE,0,0);
% aoProgramFlash(2,RTR_SG_NIOS_FLASH_PROGRAM_FILE,0,0);
% aoProgramFlash(4,RTR_SG_LOGIC_FLASH_PROGRAM_FILE,0,0);
% aoProgramFlash(3,RTR_SG_NIOS_FLASH_PROGRAM_FILE,0,0);
% mgp_op_write_flash(0,0,1,'0xfc000',161) % serial number

disp('*****************************************');