#if !defined(AFX_CLEARSRAM_VIEW_H__2589947F_03BC_4CA6_9D92_128168894B5F__INCLUDED_)
#define AFX_CLEARSRAM_VIEW_H__2589947F_03BC_4CA6_9D92_128168894B5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ClearSram_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CClearSram_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CClearSram_View : public CFormView
{
public:
	CClearSram_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CClearSram_View)

// Form Data
public:
	//{{AFX_DATA(CClearSram_View)
	enum { IDD = IDD_CLEARSRAM_VIEW };
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_SizeCtrl;
	CHexEdit	m_StartAddressCtrl;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	DWORD	m_Size;
	BOOL	m_WantReply;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClearSram_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CClearSram_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CClearSram_View)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLEARSRAM_VIEW_H__2589947F_03BC_4CA6_9D92_128168894B5F__INCLUDED_)
