#if !defined(AFX_DSPSTATUS_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
#define AFX_DSPSTATUS_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DSPStatus_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDSPStatus_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

//#define DIAGNOSTIC_ADC_GAIN    1.22213 // in mA/bit
//#define DIAGNOSTIC_ADC_OFFSET  (-1500) // in mA
#define DIAGNOSTIC_ADC_GAIN    1.20000 // in mA/bit
#define DIAGNOSTIC_ADC_OFFSET  (-1463) // in mA

class CDSPStatus_View : public CFormView
{
public:
	CDSPStatus_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDSPStatus_View)

// Form Data
public:
	//{{AFX_DATA(CDSPStatus_View)
	enum { IDD = IDD_DSPSTATUS_VIEW };
	CString	m_Status[36];
	CString	m_LogicVer;
	CString	m_NiosVer;
	CString	m_BoardSN;
	CString	m_RstStatus;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDSPStatus_View)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDSPStatus_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDSPStatus_View)
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateProgress(uint32 *p_dspfixarea,LPARAM dummy2);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DSPSTATUS_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
