#if !defined(AFX_DIAGNOSTIC_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
#define AFX_DIAGNOSTIC_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Diagnostic_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDiagnostic_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

typedef struct
	{
	CView *pView;
	BOOL  enabled;
	} tab_view_struct;

class CDiagnostic_View : public CFormView
{
public:
	CDiagnostic_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDiagnostic_View)

// Form Data
public:
	//{{AFX_DATA(CDiagnostic_View)
	enum { IDD = IDD_DIAGNOSTIC_VIEW };
	CTabCtrl	m_TabSelection;
	//}}AFX_DATA

// Attributes
public:
	CFont           m_Font;
	tab_view_struct m_TabView[20];
	DWORD           activeView;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDiagnostic_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDiagnostic_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDiagnostic_View)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelChangeTabSelection(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateProgress(void *p_data,LPARAM dummy2);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIAGNOSTIC_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
