#if !defined(AFX_READDSP_VIEW_H__F1FFD643_D481_4EA3_A427_A34179C786C0__INCLUDED_)
#define AFX_READDSP_VIEW_H__F1FFD643_D481_4EA3_A427_A34179C786C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ReadDsp_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CReadDsp_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CReadDsp_View : public CFormView
{
public:
	CReadDsp_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CReadDsp_View)

// Form Data
public:
	//{{AFX_DATA(CReadDsp_View)
	enum { IDD = IDD_READDSP_VIEW };
	CEdit	m_FileNameCtrl;
	CButton	m_Browse;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_SizeCtrl;
	CHexEdit	m_StartAddressCtrl;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	WORD	m_Size;
	BOOL	m_WantReply;
	BOOL	m_MultplePackets;
	CString	m_FileName;
	BOOL	m_ReplyToFile;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReadDsp_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CReadDsp_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CReadDsp_View)
	afx_msg void OnReplyToFile();
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_READDSP_VIEW_H__F1FFD643_D481_4EA3_A427_A34179C786C0__INCLUDED_)
