#if !defined(AFX_READSRAM_VIEW_H__1659BB93_0CD2_44D7_88C7_A9F3E0386686__INCLUDED_)
#define AFX_READSRAM_VIEW_H__1659BB93_0CD2_44D7_88C7_A9F3E0386686__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ReadSram_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CReadSram_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CReadSram_View : public CFormView
{
public:
	CReadSram_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CReadSram_View)

// Form Data
public:
	//{{AFX_DATA(CReadSram_View)
	enum { IDD = IDD_READSRAM_VIEW };
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_SizeCtrl;
	CHexEdit	m_StartAddressCtrl;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	DWORD	m_Size;
	BOOL	m_WantReply;
	BOOL	m_MultplePackets;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReadSram_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CReadSram_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CReadSram_View)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_READSRAM_VIEW_H__1659BB93_0CD2_44D7_88C7_A9F3E0386686__INCLUDED_)
