#if !defined(AFX_RELAISBOARD_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_)
#define AFX_RELAISBOARD_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RelaisBoard_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRelaisBoard_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CRelaisBoard_View : public CFormView
{
public:
	CRelaisBoard_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CRelaisBoard_View)

// Form Data
public:
	//{{AFX_DATA(CRelaisBoard_View)
	enum { IDD = IDD_RELAISBOARD_VIEW };
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_RelaisOutputCtrl;
	CHexEdit	m_RelaisOutputCtrl1;
	BYTE	   m_FirstDSP;
	BYTE	   m_LastDSP;
	DWORD    m_RelaisOutput;
	DWORD    m_RelaisOutput1;
	BOOL	   m_EnaRelaisBoard1;
	BOOL	   m_WantReply;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRelaisBoard_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CRelaisBoard_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CRelaisBoard_View)
	afx_msg void OnEnaRelaisBoard1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RELAISBOARD_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_)
