#if !defined(AFX_WRITEDSP_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_)
#define AFX_WRITEDSP_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WriteDsp_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CWriteDsp_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CWriteDsp_View : public CFormView
{
public:
	CWriteDsp_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CWriteDsp_View)

// Form Data
public:
	//{{AFX_DATA(CWriteDsp_View)
	enum { IDD = IDD_WRITEDSP_VIEW };
	CButton	m_WriteSelection0Ctrl;
	CButton	m_WriteSelection1Ctrl;
	CButton	m_WriteSelection2Ctrl;
	CEdit	m_SingleValue0Ctrl;
	CEdit	m_SingleValue1Ctrl;
	CEdit	m_SingleValue2Ctrl;
	CEdit	m_SingleValue3Ctrl;
	CEdit	m_FileNameCtrl;
	CButton	m_Browse;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_StartAddressCtrl;
	CString	m_FileName;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	BOOL	m_WantReply;
	BOOL	m_MultiplePackets;
	DWORD	m_SingleValue0;
	DWORD	m_SingleValue1;
	DWORD	m_SingleValue2;
	DWORD	m_SingleValue3;
	int	m_WriteSelection;
	//}}AFX_DATA

// Attributes
public:
	BOOL m_wrsame;

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWriteDsp_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWriteDsp_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CWriteDsp_View)
	afx_msg void OnBrowse();
	afx_msg void OnRadioFile();
	afx_msg void OnRadioQuad();
	afx_msg void OnRadioSingle();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITEDSP_VIEW_H__7D7B1563_5903_455C_AC99_96EB43AEC41B__INCLUDED_)
