// BCUStatus_View.cpp : implementation file
//

#include "stdafx.h"
#include <stdio.h>
#include <math.h>
#include "LBT_EngPanel.h"
#include "BCUStatus_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FLAGSTEXTVIEW_X  400 // 300 per video a 1024 pixels
#define FLAGSTEXTVIEW_X2 560 // 460 per video a 1024 pixels
#define FLAGSTEXTVIEW_CX 110
#define FLAGSTEXTVIEW_Y   24
#define FLAGSTEXTVIEW_CY  20
#define FLAGSICONVIEW_X  515 // 415 per video a 1024 pixels
#define FLAGSICONVIEW_X2 675 // 575 per video a 1024 pixels
#define FLAGSICONVIEW_CX  15
#define FLAGSICONVIEW_Y   20
#define FLAGSICONVIEW_CY  20

flags_struct flags[NUM_FLAGS]={"n_driver_enable",   // 00
										 "cpld_spare_3",      // 01
										 "cpld_spare_4",      // 02
										 "is_master",         // 03
										 "bus_sys_fault_n",   // 04
										 "ena_temp_n",        // 05
										 "vcc_fault",         // 06
										 "v_p_enable_ctrl",   // 07
										 "v_a_enable_ctrl",   // 08
										 "ac_power_fault0",   // 09
										 "ac_power_fault1",   // 10
										 "ac_power_fault2",   // 11
										 "ic_disconnected_n", // 12
										 "overcurrent",       // 13
										 "crate_id0",         // 14
										 "crate_id1",         // 15
										 "crate_id2",         // 16
										 "crate_id3",         // 17
										 "cpld_spare_0",      // 18
										 "dp_rdy"};           // 19

/////////////////////////////////////////////////////////////////////////////
// CBCUStatus_View

IMPLEMENT_DYNCREATE(CBCUStatus_View, CFormView)

CBCUStatus_View::CBCUStatus_View()
	: CFormView(CBCUStatus_View::IDD)
{
	//{{AFX_DATA_INIT(CBCUStatus_View)
	m_Status1 = _T("");
	m_Status2 = _T("");
	m_Status3 = _T("");
	m_Status4 = _T("");
	m_Status5 = _T("");
	m_Status6 = _T("");
	m_Status7 = _T("");
	m_Status8 = _T("");
	m_Status9 = _T("");
	m_Status10 = _T("");
	m_Status11 = _T("");
	m_Status12 = _T("");
	m_Status13 = _T("");
	m_Status14 = _T("");
	m_Status15 = _T("");
	m_Status16 = _T("");
	m_Status17 = _T("");
	m_Status18 = _T("");
	m_Status19 = _T("");
	m_Status20 = _T("");
	m_Status21 = _T("");
	//}}AFX_DATA_INIT
hGreenFlash=(HICON)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_GREENFLASH),
                             IMAGE_ICON,15,15,0);
hRedFlash=(HICON)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_REDFLASH),
                           IMAGE_ICON,15,15,0);
hGrayFlash=(HICON)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_GRAYFLASH),
                            IMAGE_ICON,15,15,0);
}

CBCUStatus_View::~CBCUStatus_View()
{
}

void CBCUStatus_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBCUStatus_View)
	DDX_Text(pDX, IDC_STATUS1, m_Status1);
	DDX_Text(pDX, IDC_STATUS2, m_Status2);
	DDX_Text(pDX, IDC_STATUS3, m_Status3);
	DDX_Text(pDX, IDC_STATUS4, m_Status4);
	DDX_Text(pDX, IDC_STATUS5, m_Status5);
	DDX_Text(pDX, IDC_STATUS6, m_Status6);
	DDX_Text(pDX, IDC_STATUS7, m_Status7);
	DDX_Text(pDX, IDC_STATUS8, m_Status8);
	DDX_Text(pDX, IDC_STATUS9, m_Status9);
	DDX_Text(pDX, IDC_STATUS10, m_Status10);
	DDX_Text(pDX, IDC_STATUS11, m_Status11);
	DDX_Text(pDX, IDC_STATUS12, m_Status12);
	DDX_Text(pDX, IDC_STATUS13, m_Status13);
	DDX_Text(pDX, IDC_STATUS14, m_Status14);
	DDX_Text(pDX, IDC_STATUS15, m_Status15);
	DDX_Text(pDX, IDC_STATUS16, m_Status16);
	DDX_Text(pDX, IDC_STATUS17, m_Status17);
	DDX_Text(pDX, IDC_STATUS18, m_Status18);
	DDX_Text(pDX, IDC_STATUS19, m_Status19);
	DDX_Text(pDX, IDC_STATUS20, m_Status20);
	DDX_Text(pDX, IDC_STATUS21, m_Status21);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBCUStatus_View, CFormView)
	//{{AFX_MSG_MAP(CBCUStatus_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBCUStatus_View diagnostics

#ifdef _DEBUG
void CBCUStatus_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CBCUStatus_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBCUStatus_View message handlers

BOOL CBCUStatus_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
DWORD i;
RECT rect1;

if (!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
	return (FALSE);

rect1=rect;

for (i=0;i<NUM_FLAGS/2;i++)
   {
   rect1.left=FLAGSTEXTVIEW_X;
   rect1.right=FLAGSTEXTVIEW_X+FLAGSTEXTVIEW_CX;
   rect1.top=FLAGSTEXTVIEW_Y+FLAGSTEXTVIEW_CY*i;
   rect1.bottom=FLAGSTEXTVIEW_Y+FLAGSTEXTVIEW_CY*(i+1);
   m_TextFlags[i].Create(flags[i].text,WS_CHILD|WS_VISIBLE,rect1,this,0);
   rect1.left=FLAGSICONVIEW_X;
   rect1.right=FLAGSICONVIEW_X+FLAGSICONVIEW_CX;
   rect1.top=FLAGSICONVIEW_Y+i*FLAGSICONVIEW_CY;
   rect1.bottom=FLAGSICONVIEW_Y+(i+1)*FLAGSICONVIEW_CY;
   m_IconFlags[i].Create(NULL,WS_CHILD|WS_VISIBLE|SS_ICON|SS_CENTERIMAGE,rect1,this,0);
	m_IconFlags[i].SetIcon(hGrayFlash);
	}
for (i=0;i<NUM_FLAGS/2;i++)
   {
   rect1.left=FLAGSTEXTVIEW_X2;
   rect1.right=FLAGSTEXTVIEW_X2+FLAGSTEXTVIEW_CX;
   rect1.top=FLAGSTEXTVIEW_Y+FLAGSTEXTVIEW_CY*i;
   rect1.bottom=FLAGSTEXTVIEW_Y+FLAGSTEXTVIEW_CY*(i+1);
   m_TextFlags[i+NUM_FLAGS/2].Create(flags[i+NUM_FLAGS/2].text,WS_CHILD|WS_VISIBLE,rect1,this,0);
   rect1.left=FLAGSICONVIEW_X2;
   rect1.right=FLAGSICONVIEW_X2+FLAGSICONVIEW_CX;
   rect1.top=FLAGSICONVIEW_Y+i*FLAGSICONVIEW_CY;
   rect1.bottom=FLAGSICONVIEW_Y+(i+1)*FLAGSICONVIEW_CY;
   m_IconFlags[i+NUM_FLAGS/2].Create(NULL,WS_CHILD|WS_VISIBLE|SS_ICON|SS_CENTERIMAGE,rect1,this,0);
	m_IconFlags[i+NUM_FLAGS/2].SetIcon(hGrayFlash);
	}

return (TRUE);
}

void CBCUStatus_View::OnInitialUpdate() 
{
uint32 i;

CFormView::OnInitialUpdate();

for (i=0;i<NUM_FLAGS;i++)
   m_TextFlags[i].SetFont(GetFont(),TRUE);
}

double gain_matrix[]={
	0.0000E+00,	0.0078125,		0.0000E+00,		// stratix_temp
	0.0000E+00,	0.0078125,		0.0000E+00,		// power_temp
	0.0000E+00,	0.0000E+00,		0.0000E+00,		// bck_digitalIO (LSW)
	0.0000E+00,	0.0000E+00,		0.0000E+00,		// bck_digitalIO (MSW)
	0.0000E+00,	1.0173E-03,		0.0000E+00,		// VCC_L
	0.0000E+00,	3.4790E-03,		0.0000E+00,		// VCC_A
	0.0000E+00,	-6.1035E-03,	8.7925E+00,		// VSS_A
	0.0000E+00,	3.4790E-03,		0.0000E+00,		// VCC_P
	0.0000E+00,	-6.1035E-03,	8.7925E+00,		// VSS_P
	0.0000E+00,	1.2986E-02,		0.0000E+00,		// I_VCC_L
	0.0000E+00,	2.7743E-03,		0.0000E+00,		// I_VCC_A
	0.0000E+00,	-2.7785E-03,	0.0000E+00,		// I_VSS_A
	0.0000E+00,	5.5235E-03,		0.0000E+00,		// I_VCC_P
	0.0000E+00,	-5.5191E-03,	0.0000E+00,		// I_VSS_P
	0.0000E+00,	2.0296E-03,		0.0000E+00,		// I_TOT_VCC_P
	0.0000E+00,	-2.0280E-03,	0.0000E+00,		// I_TOT_VSS_P
	0.0000E+00,	4.0592E-03,		-8.3133E+00,	// I_TOT_DIFF
	1.5823E-06,	-3.4667E-02,	7.7418E+01,		// IN0_TEMP
	1.5823E-06,	-3.4667E-02,	7.7418E+01,		// IN1_TEMP
	1.5823E-06,	-3.4667E-02,	7.7418E+01,		// OUT0_TEMP
	1.5823E-06,	-3.4667E-02,	7.7418E+01,		// OUT1_TEMP
	0.0000E+00,	3.8638E-02,		-2.5764E+01,	// HUMIDITY
	0.0000E+00,	-3.7602E-03,	7.7009E+00,		// PRESSURE
	0.0000E+00,	2.8288E+00,		0.0000E+00,		// LOCAL VCC_P/VSS_P THRESHOLD (bit/A)
	0.0000E+00,	1.1283E+01,		-1.0391E+02,	// VCC_P/VSS_P SET  (bit/V)
	0.0000E+00,	2.5744E-01,		3.2000E+01,		// TOTAL VCC_P THRESHOLD  (bit/A) 
	0.0000E+00,	-2.5744E-01,	3.2000E+01,		// TOTAL VSS_P THRESHOLD  (bit/A)
	0.0000E+00,	0.353506787,	0.0000E+00,		// LOCAL VCC_P/VSS_P THRESHOLD (A/bit)
	0.0000E+00,	0.08862734,		9.2093E+00,		// VCC_P/VSS_P SET  (V/bit)
	0.0000E+00,	3.88437023,		-1.2430E+02,	// TOTAL VCC_P THRESHOLD  (A/bit) 
	0.0000E+00,	-3.88437023,	1.2430E+02,		// TOTAL VSS_P THRESHOLD  (A/bit)
	};

LRESULT CBCUStatus_View::OnUpdateProgress(na_bcu_diagnostic_struct *diagnostic_area_ptr,LPARAM dummy2)
{
uint16 *val;
double conv_val;
uint32 i;
char str[100];

UpdateData(TRUE);

val=(uint16 *)diagnostic_area_ptr;

i=0;
conv_val=pow(((int16 *)val)[i],2)*gain_matrix[0+i*3]+((int16 *)val)[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%5.0f",conv_val); // diagnostic_area_ptr->stratix_temp
m_Status1=str;
conv_val=pow(((int16 *)val)[i],2)*gain_matrix[0+i*3]+((int16 *)val)[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i+=3;
sprintf(str,"%5.0f",conv_val); // diagnostic_area_ptr->power_temp
m_Status2=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->voltage_vccl
m_Status3=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->voltage_vcca
m_Status4=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->voltage_vssa
m_Status5=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->voltage_vccp
m_Status6=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->voltage_vssp
m_Status7=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->current_vccl
m_Status8=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->current_vcca
m_Status9=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->current_vssa
m_Status10=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->current_vccp
m_Status11=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->current_vssp
m_Status12=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->tot_current_vccp
m_Status13=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->tot_current_vssp
m_Status14=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->tot_current_vp
m_Status15=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->in0_temp
m_Status16=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->in1_temp
m_Status17=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->out0_temp
m_Status18=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->out1_temp
m_Status19=str;
conv_val=pow(val[i],2)*gain_matrix[0+i*3]+val[i]*gain_matrix[1+i*3]+gain_matrix[2+i*3];i++;
sprintf(str,"%6.2f",conv_val); // diagnostic_area_ptr->ext_umidity
m_Status20=str;
sprintf(str,"0x%08x",diagnostic_area_ptr->bck_digitalIO);
m_Status21=str;

UpdateData(FALSE);

for (i=0;i<NUM_FLAGS;i++)
   {
   if (diagnostic_area_ptr->bck_digitalIO&(1<<i))
		m_IconFlags[i].SetIcon(hRedFlash);
	else
      m_IconFlags[i].SetIcon(hGreenFlash);
   }

return (0);
}
