// DSPStatus_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "DSPStatus_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDSPStatus_View

IMPLEMENT_DYNCREATE(CDSPStatus_View, CFormView)

CDSPStatus_View::CDSPStatus_View()
	: CFormView(CDSPStatus_View::IDD)
{
	//{{AFX_DATA_INIT(CDSPStatus_View)
	m_Status[36] = _T("");
	m_LogicVer = _T("");
	m_NiosVer = _T("");
	m_BoardSN = _T("");
	m_RstStatus = _T("");
	//}}AFX_DATA_INIT
}

CDSPStatus_View::~CDSPStatus_View()
{
}

void CDSPStatus_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSPStatus_View)
	DDX_Text(pDX, IDC_STATUS1, m_Status[0]);
	DDX_Text(pDX, IDC_STATUS2, m_Status[1]);
	DDX_Text(pDX, IDC_STATUS3, m_Status[2]);
	DDX_Text(pDX, IDC_STATUS4, m_Status[3]);
	DDX_Text(pDX, IDC_STATUS5, m_Status[4]);
	DDX_Text(pDX, IDC_STATUS6, m_Status[5]);
	DDX_Text(pDX, IDC_STATUS7, m_Status[6]);
	DDX_Text(pDX, IDC_STATUS8, m_Status[7]);
	DDX_Text(pDX, IDC_STATUS9, m_Status[8]);
	DDX_Text(pDX, IDC_STATUS10, m_Status[9]);
	DDX_Text(pDX, IDC_STATUS11, m_Status[10]);
	DDX_Text(pDX, IDC_STATUS12, m_Status[11]);
	DDX_Text(pDX, IDC_STATUS13, m_Status[12]);
	DDX_Text(pDX, IDC_STATUS14, m_Status[13]);
	DDX_Text(pDX, IDC_STATUS15, m_Status[14]);
	DDX_Text(pDX, IDC_STATUS16, m_Status[15]);
	DDX_Text(pDX, IDC_STATUS17, m_Status[16]);
	DDX_Text(pDX, IDC_STATUS18, m_Status[17]);
	DDX_Text(pDX, IDC_STATUS19, m_Status[18]);
	DDX_Text(pDX, IDC_STATUS20, m_Status[19]);
	DDX_Text(pDX, IDC_STATUS21, m_Status[20]);
	DDX_Text(pDX, IDC_STATUS22, m_Status[21]);
	DDX_Text(pDX, IDC_STATUS23, m_Status[22]);
	DDX_Text(pDX, IDC_STATUS24, m_Status[23]);
	DDX_Text(pDX, IDC_STATUS25, m_Status[24]);
	DDX_Text(pDX, IDC_STATUS26, m_Status[25]);
	DDX_Text(pDX, IDC_STATUS27, m_Status[25]);
	DDX_Text(pDX, IDC_STATUS28, m_Status[27]);
	DDX_Text(pDX, IDC_STATUS29, m_Status[28]);
	DDX_Text(pDX, IDC_STATUS30, m_Status[29]);
	DDX_Text(pDX, IDC_STATUS31, m_Status[30]);
	DDX_Text(pDX, IDC_STATUS32, m_Status[31]);
	DDX_Text(pDX, IDC_STATUS33, m_Status[32]);
	DDX_Text(pDX, IDC_STATUS34, m_Status[33]);
	DDX_Text(pDX, IDC_STATUS35, m_Status[34]);
	DDX_Text(pDX, IDC_STATUS36, m_Status[35]);
	DDX_Text(pDX, IDC_LOGICVER, m_LogicVer);
	DDX_Text(pDX, IDC_NIOSVER, m_NiosVer);
	DDX_Text(pDX, IDC_BOARDSN, m_BoardSN);
	DDX_Text(pDX, IDC_RSTSTATUS, m_RstStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDSPStatus_View, CFormView)
	//{{AFX_MSG_MAP(CDSPStatus_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSPStatus_View diagnostics

#ifdef _DEBUG
void CDSPStatus_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CDSPStatus_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDSPStatus_View message handlers

BOOL CDSPStatus_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CDSPStatus_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
}

LRESULT CDSPStatus_View::OnUpdateProgress(uint32 *p_dspfixarea,LPARAM dummy2)
{
na_dsp_nios_fixed_area_simply_struct_8ch  *dspfixarea_8ch_ptr;
na_dsp_nios_fixed_area_simply_struct_16ch *dspfixarea_16ch_ptr;
na_dsp_diagnostic_struct_8ch  *diagnostic_area_8ch_ptr;
na_dsp_diagnostic_struct_16ch *diagnostic_area_16ch_ptr;
char str[100];
DWORD id,i;
double coil_curr,coil_volt;

UpdateData(TRUE);

if ((p_dspfixarea[1]&0xFF000000)==0x05000000)
	{
	dspfixarea_16ch_ptr=(na_dsp_nios_fixed_area_simply_struct_16ch *)p_dspfixarea;
	diagnostic_area_16ch_ptr=&dspfixarea_16ch_ptr->diagnostic_area;

	id=0;
	sprintf(str,"%5.0f",(double)diagnostic_area_16ch_ptr->stratix_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_16ch_ptr->power_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_16ch_ptr->dsps_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_16ch_ptr->driverA_temp*0.0078125);
	m_Status[id++]=str;
	for (i=0;i<8;i++)
		{
	// vecchia formula con coefficienti di correzione rispetto al valore nominale
	//	coil_curr=(DIAGNOSTIC_ADC_GAIN/p_dspfixarea->ADC_spi_gain[i])*(double)(diagnostic_area_ptr->coil_current[i]&0x0FFF);
	//	coil_curr+=(DIAGNOSTIC_ADC_OFFSET-p_dspfixarea->ADC_spi_offset[i])/p_dspfixarea->ADC_spi_gain[i];
	// nuova formula con calcolo diretto dai coefficienti in sram
		coil_curr=(double)(diagnostic_area_16ch_ptr->coil_current[i]&0x0FFF);
		coil_volt=(double)(diagnostic_area_16ch_ptr->coil_voltage[i]&0x0FFF);
		sprintf(str,"curr 0x%04x - volt 0x%04x",diagnostic_area_16ch_ptr->coil_current[i]&0x0FFF,diagnostic_area_16ch_ptr->coil_voltage[i]&0x0FFF);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_16ch_ptr->ADC_offset[i],dspfixarea_16ch_ptr->ADC_gain[i]);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_16ch_ptr->ADC_spi_offset[i],dspfixarea_16ch_ptr->ADC_spi_gain[i]);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_16ch_ptr->DAC_offset[i],dspfixarea_16ch_ptr->DAC_gain[i]);
		m_Status[id++]=str;
		}
	sprintf(str,"v%x.%02x",(dspfixarea_16ch_ptr->logic_release>>8)&0x00FF,dspfixarea_16ch_ptr->logic_release&0x00FF);
	m_LogicVer=str;
	sprintf(str,"v%x.%02x.%04x",(dspfixarea_16ch_ptr->software_release>>24)&0xFF,(dspfixarea_16ch_ptr->software_release>>16)&0xFF,dspfixarea_16ch_ptr->software_release&0xFFFF);
	m_NiosVer=str;
	sprintf(str,"%04d",dspfixarea_16ch_ptr->serial_number);
	m_BoardSN=str;
	sprintf(str,"0x%08x",diagnostic_area_16ch_ptr->driver_status&0xFFFFFF7F);
	m_RstStatus=str;
	}
else
	{
	dspfixarea_8ch_ptr=(na_dsp_nios_fixed_area_simply_struct_8ch *)p_dspfixarea;
	diagnostic_area_8ch_ptr=&dspfixarea_8ch_ptr->diagnostic_area;

	id=0;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->stratix_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->power_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->dsps_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->driver_temp*0.0078125);
	m_Status[id++]=str;
	for (i=0;i<8;i++)
		{
	// vecchia formula con coefficienti di correzione rispetto al valore nominale
	//	coil_curr=(DIAGNOSTIC_ADC_GAIN/p_dspfixarea->ADC_spi_gain[i])*(double)(diagnostic_area_ptr->coil_current[i]&0x0FFF);
	//	coil_curr+=(DIAGNOSTIC_ADC_OFFSET-p_dspfixarea->ADC_spi_offset[i])/p_dspfixarea->ADC_spi_gain[i];
	// nuova formula con calcolo diretto dai coefficienti in sram
		coil_curr=(double)(diagnostic_area_8ch_ptr->coil_current[i]&0x0FFF)*dspfixarea_8ch_ptr->ADC_spi_gain[i]+dspfixarea_8ch_ptr->ADC_spi_offset[i];
		sprintf(str,"%5.0f",coil_curr*1000);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_8ch_ptr->ADC_offset[i],dspfixarea_8ch_ptr->ADC_gain[i]);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_8ch_ptr->ADC_spi_offset[i],dspfixarea_8ch_ptr->ADC_spi_gain[i]);
		m_Status[id++]=str;
		}
	for (i=0;i<8;i++)
		{
		sprintf(str,"Offset: %5.3e - Gain: %5.3e",dspfixarea_8ch_ptr->DAC_offset[i],dspfixarea_8ch_ptr->DAC_gain[i]);
		m_Status[id++]=str;
		}
	sprintf(str,"v%x.%02x",(dspfixarea_8ch_ptr->logic_release>>8)&0x00FF,dspfixarea_8ch_ptr->logic_release&0x00FF);
	m_LogicVer=str;
	sprintf(str,"v%x.%02x.%04x",(dspfixarea_8ch_ptr->software_release>>24)&0xFF,(dspfixarea_8ch_ptr->software_release>>16)&0xFF,dspfixarea_8ch_ptr->software_release&0xFFFF);
	m_NiosVer=str;
	sprintf(str,"%04d",dspfixarea_8ch_ptr->serial_number);
	m_BoardSN=str;
	sprintf(str,"0x%08x",diagnostic_area_8ch_ptr->driver_status);
	m_RstStatus=str;
	}

UpdateData(FALSE);
return (0);
}
