// SigGenStatus_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "SigGenStatus_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSigGenStatus_View

IMPLEMENT_DYNCREATE(CSigGenStatus_View, CFormView)

CSigGenStatus_View::CSigGenStatus_View()
	: CFormView(CSigGenStatus_View::IDD)
{
	//{{AFX_DATA_INIT(CSigGenStatus_View)
	m_Status[2] = _T("");
	m_LogicVer = _T("");
	m_NiosVer = _T("");
	m_BoardSN = _T("");
	m_RstStatus = _T("");
	//}}AFX_DATA_INIT
}

CSigGenStatus_View::~CSigGenStatus_View()
{
}

void CSigGenStatus_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSigGenStatus_View)
	DDX_Text(pDX, IDC_STATUS1, m_Status[0]);
	DDX_Text(pDX, IDC_STATUS2, m_Status[1]);
	DDX_Text(pDX, IDC_LOGICVER, m_LogicVer);
	DDX_Text(pDX, IDC_NIOSVER, m_NiosVer);
	DDX_Text(pDX, IDC_BOARDSN, m_BoardSN);
	DDX_Text(pDX, IDC_RSTSTATUS, m_RstStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSigGenStatus_View, CFormView)
	//{{AFX_MSG_MAP(CSigGenStatus_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSigGenStatus_View diagnostics

#ifdef _DEBUG
void CSigGenStatus_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSigGenStatus_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSigGenStatus_View message handlers

BOOL CSigGenStatus_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSigGenStatus_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
}

LRESULT CSigGenStatus_View::OnUpdateProgress(uint32 *p_dspfixarea,LPARAM dummy2)
{
na_dsp_nios_fixed_area_simply_struct_8ch  *dspfixarea_8ch_ptr;
na_dsp_diagnostic_struct_8ch  *diagnostic_area_8ch_ptr;
char str[100];
DWORD id;

UpdateData(TRUE);

if ((p_dspfixarea[1]&0xFF000000)==0x05000000)
	{
	InternalError(100);
	}
else
	{
	dspfixarea_8ch_ptr=(na_dsp_nios_fixed_area_simply_struct_8ch *)p_dspfixarea;
	diagnostic_area_8ch_ptr=&dspfixarea_8ch_ptr->diagnostic_area;

	id=0;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->stratix_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"%5.0f",(double)diagnostic_area_8ch_ptr->power_temp*0.0078125);
	m_Status[id++]=str;
	sprintf(str,"v%x.%02x",(dspfixarea_8ch_ptr->logic_release>>8)&0x00FF,dspfixarea_8ch_ptr->logic_release&0x00FF);
	m_LogicVer=str;
	sprintf(str,"v%x.%02x.%04x",(dspfixarea_8ch_ptr->software_release>>24)&0xFF,(dspfixarea_8ch_ptr->software_release>>16)&0xFF,dspfixarea_8ch_ptr->software_release&0xFFFF);
	m_NiosVer=str;
	sprintf(str,"%04d",dspfixarea_8ch_ptr->serial_number);
	m_BoardSN=str;
	sprintf(str,"0x%08x",diagnostic_area_8ch_ptr->driver_status);
	m_RstStatus=str;
	}

UpdateData(FALSE);
return (0);
}
