// UnlockFlash_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "UnlockFlash_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnlockFlash_View

IMPLEMENT_DYNCREATE(CUnlockFlash_View, CFormView)

CUnlockFlash_View::CUnlockFlash_View()
	: CFormView(CUnlockFlash_View::IDD)
{
	//{{AFX_DATA_INIT(CUnlockFlash_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_WantReply = TRUE;
	//}}AFX_DATA_INIT
}

CUnlockFlash_View::~CUnlockFlash_View()
{
}

void CUnlockFlash_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnlockFlash_View)
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnlockFlash_View, CFormView)
	//{{AFX_MSG_MAP(CUnlockFlash_View)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnlockFlash_View diagnostics

#ifdef _DEBUG
void CUnlockFlash_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CUnlockFlash_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CUnlockFlash_View message handlers

BOOL CUnlockFlash_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CUnlockFlash_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
}

DWORD CUnlockFlash_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;

(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*1);
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*1);
// alloco il (*buffer) a dimensione massima
(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[0],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[0];
pData=(uint32 *)((*buffer)[0]+MGP_HLEN);

tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_UNLOCK_FLASH;
tx_mgp->len=0;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0;

(*bufferLen)[0]=MGP_HLEN+tx_mgp->len*4;

return (1);
}
