// WrRdFLDspTest_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WrRdFLDspTest_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWrRdFLDspTest_View

IMPLEMENT_DYNCREATE(CWrRdFLDspTest_View, CFormView)

CWrRdFLDspTest_View::CWrRdFLDspTest_View()
	: CFormView(CWrRdFLDspTest_View::IDD)
{
	//{{AFX_DATA_INIT(CWrRdFLDspTest_View)
	m_OutText1 = _T("");
	m_OutText2 = _T("");
	m_OutText3 = _T("");
	m_OutText4 = _T("");
	m_OutText5 = _T("");
	m_OutText6 = _T("");
	m_OutText7 = _T("");
	m_OutText8 = _T("");
	m_OutText9 = _T("");
	m_OutText10 = _T("");
	m_OutText11 = _T("");
	m_OutText12 = _T("");
	m_Text = _T("");
	//}}AFX_DATA_INIT
}

CWrRdFLDspTest_View::~CWrRdFLDspTest_View()
{
}

void CWrRdFLDspTest_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWrRdFLDspTest_View)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Text(pDX, IDC_OUTTEXT1, m_OutText1);
	DDX_Text(pDX, IDC_OUTTEXT2, m_OutText2);
	DDX_Text(pDX, IDC_OUTTEXT3, m_OutText3);
	DDX_Text(pDX, IDC_OUTTEXT4, m_OutText4);
	DDX_Text(pDX, IDC_OUTTEXT5, m_OutText5);
	DDX_Text(pDX, IDC_OUTTEXT6, m_OutText6);
	DDX_Text(pDX, IDC_OUTTEXT7, m_OutText7);
	DDX_Text(pDX, IDC_OUTTEXT8, m_OutText8);
	DDX_Text(pDX, IDC_OUTTEXT9, m_OutText9);
	DDX_Text(pDX, IDC_OUTTEXT10, m_OutText10);
	DDX_Text(pDX, IDC_OUTTEXT11, m_OutText11);
	DDX_Text(pDX, IDC_OUTTEXT12, m_OutText12);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWrRdFLDspTest_View, CFormView)
	//{{AFX_MSG_MAP(CWrRdFLDspTest_View)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
	ON_MESSAGE(WM_SET_PROGRESS, OnSetProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWrRdFLDspTest_View diagnostics

#ifdef _DEBUG
void CWrRdFLDspTest_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWrRdFLDspTest_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWrRdFLDspTest_View message handlers

BOOL CWrRdFLDspTest_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWrRdFLDspTest_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_Progress.SetPos(0);
}

LRESULT CWrRdFLDspTest_View::OnUpdateProgress(DWORD elapsedTime,DWORD *pUpdateData)
{
double num_bit_sent;
DWORD  wr_buffer_size = 0x1000; // 0x10 = dimensione del buffer di scrittura sui DSP
DWORD  num_dsp        = 2;      // numero dei DSP su cui eseguo il test

UpdateData(TRUE);
m_OutText1.Format("%02d:%02d:%02d.%03d",elapsedTime/3600000,(elapsedTime/60000)-(elapsedTime/3600000)*60,(elapsedTime/1000)-(elapsedTime/60000)*60,elapsedTime%1000);
num_bit_sent=((double)pUpdateData[0]+(double)pUpdateData[1]*0x100000000)/2*wr_buffer_size*(num_dsp+1)*32;
m_OutText2.Format("%.3e",num_bit_sent);
if (elapsedTime)
	m_OutText3.Format("%.3f",num_bit_sent/(double)elapsedTime/1000.);
else
	m_OutText3.Format("");
m_OutText4.Format("%d",(UINT64)pUpdateData[0]+(UINT64)pUpdateData[1]*0x100000000);
m_OutText5.Format("%d",(UINT64)pUpdateData[2]+(UINT64)pUpdateData[3]*0x100000000);
m_OutText6.Format("%d",(UINT64)pUpdateData[12]+(UINT64)pUpdateData[13]*0x100000000);
m_OutText7.Format("");
m_OutText8.Format("");
m_OutText9.Format("%d",(UINT64)pUpdateData[8]+(UINT64)pUpdateData[9]*0x100000000);
m_OutText10.Format("%d",(UINT64)pUpdateData[10]+(UINT64)pUpdateData[11]*0x100000000);
m_OutText11.Format("%d",(UINT64)pUpdateData[4]+(UINT64)pUpdateData[5]*0x100000000);
m_OutText12.Format("%d",(UINT64)pUpdateData[6]+(UINT64)pUpdateData[7]*0x100000000);
UpdateData(FALSE);

m_Progress.SetPos(pUpdateData[1]&0xFFFF);
return (0);
}

LRESULT CWrRdFLDspTest_View::OnSetProgress(UINT range,LPARAM dummy2)
{
UpdateData(TRUE);
if (range==-1)
	{ // reset
	m_Text="";
	m_Progress.SetPos(0);
	}
else
	{ // reset
	m_Text="Write/Read FastLink Test in process...";
	m_Progress.SetRange32(0,range);
	m_Progress.SetPos(0);
	}
UpdateData(FALSE);
return (0);
}
