// WriteDsp_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteDsp_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define MAX_MGP_DATA_SIZE_LOC MAX_MGP_DATA_SIZE
#define MAX_MGP_DATA_SIZE_LOC JUMBO_MAX_MGP_DATA_SIZE

/////////////////////////////////////////////////////////////////////////////
// CWriteDsp_View

IMPLEMENT_DYNCREATE(CWriteDsp_View, CFormView)

CWriteDsp_View::CWriteDsp_View()
	: CFormView(CWriteDsp_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteDsp_View)
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\Lbt\\Codes\\LBT_EngPanel\\v2.00\\pippo1.dat");
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0;
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	m_SingleValue0 = 0;
	m_SingleValue1 = 0;
	m_SingleValue2 = 0;
	m_SingleValue3 = 0;
	m_WriteSelection = 0;
	//}}AFX_DATA_INIT
	m_wrsame = FALSE;
}

CWriteDsp_View::~CWriteDsp_View()
{
}

void CWriteDsp_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteDsp_View)
	DDX_Control(pDX, IDC_RADIO_FILE, m_WriteSelection0Ctrl);
	DDX_Control(pDX, IDC_RADIO_SINGLE, m_WriteSelection1Ctrl);
	DDX_Control(pDX, IDC_RADIO_QUAD, m_WriteSelection2Ctrl);
	DDX_Control(pDX, IDC_SINGLEVALUE0, m_SingleValue0Ctrl);
	DDX_Control(pDX, IDC_SINGLEVALUE1, m_SingleValue1Ctrl);
	DDX_Control(pDX, IDC_SINGLEVALUE2, m_SingleValue2Ctrl);
	DDX_Control(pDX, IDC_SINGLEVALUE3, m_SingleValue3Ctrl);
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	DDX_HexText(pDX, IDC_SINGLEVALUE0, m_SingleValue0);
	DDX_HexText(pDX, IDC_SINGLEVALUE1, m_SingleValue1);
	DDX_HexText(pDX, IDC_SINGLEVALUE2, m_SingleValue2);
	DDX_HexText(pDX, IDC_SINGLEVALUE3, m_SingleValue3);
	DDX_Radio(pDX, IDC_RADIO_FILE, m_WriteSelection);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWriteDsp_View, CFormView)
	//{{AFX_MSG_MAP(CWriteDsp_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_RADIO_FILE, OnRadioFile)
	ON_BN_CLICKED(IDC_RADIO_QUAD, OnRadioQuad)
	ON_BN_CLICKED(IDC_RADIO_SINGLE, OnRadioSingle)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteDsp_View diagnostics

#ifdef _DEBUG
void CWriteDsp_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteDsp_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteDsp_View message handlers

BOOL CWriteDsp_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteDsp_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
m_SingleValue0Ctrl.LimitText(8);
m_SingleValue1Ctrl.LimitText(8);
m_SingleValue2Ctrl.LimitText(8);
m_SingleValue3Ctrl.LimitText(8);

UpdateData(TRUE);

if (m_WriteSelection==0)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	m_SingleValue0Ctrl.EnableWindow(FALSE);
	m_SingleValue1Ctrl.EnableWindow(FALSE);
	m_SingleValue2Ctrl.EnableWindow(FALSE);
	m_SingleValue3Ctrl.EnableWindow(FALSE);
	}
else if (m_WriteSelection==1)
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	m_SingleValue0Ctrl.EnableWindow(TRUE);
	m_SingleValue1Ctrl.EnableWindow(FALSE);
	m_SingleValue2Ctrl.EnableWindow(FALSE);
	m_SingleValue3Ctrl.EnableWindow(FALSE);
	}
else if (m_WriteSelection==2)
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	m_SingleValue0Ctrl.EnableWindow(TRUE);
	m_SingleValue1Ctrl.EnableWindow(TRUE);
	m_SingleValue2Ctrl.EnableWindow(TRUE);
	m_SingleValue3Ctrl.EnableWindow(TRUE);
	}
}

DWORD CWriteDsp_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets,i1;
char   tmpbuff[100];

UpdateData(TRUE);

if (m_FirstDSP==0xFF || m_FirstDSP==0xFE)
	numDSP = 1;
else
	numDSP = m_LastDSP - m_FirstDSP + 1;

if (m_WriteSelection==0)
	{
	packetID=(BYTE *)(*bufferLen);
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=0;
	start_addr=m_StartAddress;

	// determino la lunghezza del file binario
	fd=fopen(m_FileName,"rt");
	if (!fd)
		{
		AfxMessageBox("Input file name not valid");
		return (0);
		}
	do
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		if (m_wrsame==TRUE)
			tx_mgp->op=MGP_OP_WRSAME_DSP;
		else
			tx_mgp->op=MGP_OP_WRSEQ_DSP;
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		// lettura del data file
		i=0;
		while (i<MAX_MGP_DATA_SIZE_LOC>>2 && fscanf(fd,"%s",tmpbuff)!=-1)
			{
			pData[i]=0;
			strlwr(tmpbuff);
			if (tmpbuff[0]=='#')
				{
				}
			else if (tmpbuff[0]=='0' && tmpbuff[1]=='x')
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='a' && tmpbuff[2+i1]<='f')
						{
						pData[i]=pData[i]*16+tmpbuff[2+i1]-'a'+10;
						i1++;
						}
					else if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						pData[i]=pData[i]*16+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						i++;
						break;
						}
					else
						break;
					}
				}
			else
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						pData[i]=pData[i]*10+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						i++;
						break;
						}
					else
						break;
					}
				}
			}
		// determino la dimensione del pacchetto come multiplo di 4 DWORD nel caso sia >= 8
		if (m_wrsame==FALSE)	i/=numDSP;
		if (i>=8) i&=0xFFFFFFFC;
		(*bufferLen)[numPackets]=i*4*numDSP;
		tx_mgp->len=i;
		start_addr+=i;
		(*bufferLen)[numPackets]+=MGP_HLEN;
		}
	while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);

	fclose(fd);
	}
else if (m_WriteSelection==1)
	{
	packetID=(BYTE *)(*bufferLen);
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=1;
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*numPackets);
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*numPackets);
	// alloco il (*buffer) a dimensione massima
	(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
	memset((*buffer)[0],0,MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[0];
	pData=(uint32 *)((*buffer)[0]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	if (m_wrsame==TRUE)
		tx_mgp->op=MGP_OP_WRSAME_DSP;
	else
		tx_mgp->op=MGP_OP_WRSEQ_DSP;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=m_StartAddress;
	(*bufferLen)[0]=4;          // 4 bytes
	tx_mgp->len=1;              // 1 dword
	pData[0]=m_SingleValue0;
	(*bufferLen)[0]+=MGP_HLEN;
	}
else if (m_WriteSelection==2)
	{
	packetID=(BYTE *)(*bufferLen);
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=1;
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*numPackets);
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*numPackets);
	// alloco il (*buffer) a dimensione massima
	(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
	memset((*buffer)[0],0,MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[0];
	pData=(uint32 *)((*buffer)[0]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	if (m_wrsame==TRUE)
		tx_mgp->op=MGP_OP_WRSAME_DSP;
	else
		tx_mgp->op=MGP_OP_WRSEQ_DSP;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->fl+=MGP_FL_ASQUADWORD;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=m_StartAddress;
	(*bufferLen)[0]=16;          // 16 bytes
	tx_mgp->len=4;               // 4 dword
	pData[0]=m_SingleValue0;
	pData[1]=m_SingleValue1;
	pData[2]=m_SingleValue2;
	pData[3]=m_SingleValue3;
	(*bufferLen)[0]+=MGP_HLEN;
	}

return (numPackets);
}

void CWriteDsp_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select data file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}

void CWriteDsp_View::OnRadioFile() 
{
m_Browse.EnableWindow(TRUE);
m_FileNameCtrl.EnableWindow(TRUE);
m_SingleValue0Ctrl.EnableWindow(FALSE);
m_SingleValue1Ctrl.EnableWindow(FALSE);
m_SingleValue2Ctrl.EnableWindow(FALSE);
m_SingleValue3Ctrl.EnableWindow(FALSE);
}

void CWriteDsp_View::OnRadioQuad() 
{
m_Browse.EnableWindow(FALSE);
m_FileNameCtrl.EnableWindow(FALSE);
m_SingleValue0Ctrl.EnableWindow(TRUE);
m_SingleValue1Ctrl.EnableWindow(TRUE);
m_SingleValue2Ctrl.EnableWindow(TRUE);
m_SingleValue3Ctrl.EnableWindow(TRUE);
}

void CWriteDsp_View::OnRadioSingle() 
{
m_Browse.EnableWindow(FALSE);
m_FileNameCtrl.EnableWindow(FALSE);
m_SingleValue0Ctrl.EnableWindow(TRUE);
m_SingleValue1Ctrl.EnableWindow(FALSE);
m_SingleValue2Ctrl.EnableWindow(FALSE);
m_SingleValue3Ctrl.EnableWindow(FALSE);
}


void CWriteDsp_View::OnShowWindow(BOOL bShow, UINT nStatus) 
{
CFormView::OnShowWindow(bShow, nStatus);
	
if (m_wrsame==1)
	{
	if (::IsWindow(m_WriteSelection0Ctrl.m_hWnd)) m_WriteSelection0Ctrl.EnableWindow(TRUE);
	if (::IsWindow(m_WriteSelection1Ctrl.m_hWnd)) m_WriteSelection1Ctrl.EnableWindow(TRUE);
	if (::IsWindow(m_WriteSelection2Ctrl.m_hWnd)) m_WriteSelection2Ctrl.EnableWindow(TRUE);
	}
else	
	{
	if (::IsWindow(m_WriteSelection0Ctrl.m_hWnd)) m_WriteSelection0Ctrl.EnableWindow(TRUE);
	if (::IsWindow(m_WriteSelection1Ctrl.m_hWnd)) m_WriteSelection1Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_WriteSelection2Ctrl.m_hWnd)) m_WriteSelection2Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_SingleValue0Ctrl.m_hWnd)) m_SingleValue0Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_SingleValue1Ctrl.m_hWnd)) m_SingleValue1Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_SingleValue2Ctrl.m_hWnd)) m_SingleValue2Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_SingleValue3Ctrl.m_hWnd)) m_SingleValue3Ctrl.EnableWindow(FALSE);
	}
}
