// EthernetCardSelect.cpp : implementation file
//

#include "stdafx.h"
#include "lbt_engpanel.h"
#include "EthernetCardSelect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEthernetCardSelect dialog


CEthernetCardSelect::CEthernetCardSelect(ADAPTERS_INFO *pAdaptersInfo,CWnd* pParent /*=NULL*/)
	: CDialog(CEthernetCardSelect::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEthernetCardSelect)
	m_EthCard = 0;
	//}}AFX_DATA_INIT
	m_pAdaptersInfo=pAdaptersInfo;
}

void CEthernetCardSelect::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEthernetCardSelect)
	DDX_Radio(pDX, IDC_RADIO1, m_EthCard);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RADIO1, m_EthCardCtrl[0]);
	DDX_Control(pDX, IDC_RADIO2, m_EthCardCtrl[1]);
	DDX_Control(pDX, IDC_RADIO3, m_EthCardCtrl[2]);
	DDX_Control(pDX, IDC_RADIO4, m_EthCardCtrl[3]);
}


BEGIN_MESSAGE_MAP(CEthernetCardSelect, CDialog)
	//{{AFX_MSG_MAP(CEthernetCardSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEthernetCardSelect message handlers

BOOL CEthernetCardSelect::OnInitDialog()
{
char str[200],*ptr;
ULONG i;
CDialog::OnInitDialog();

if (m_pAdaptersInfo->NumAdapters>4)
	InternalError(201);

for (i=0;i<m_pAdaptersInfo->NumAdapters;i++)
	{
	m_EthCardCtrl[i].EnableWindow(TRUE);
	strcpy(str,m_pAdaptersInfo->AdapterName[i]);
	ptr=str;
	while (*ptr!='-' && *ptr!='\0') ptr++;
	*ptr='\0';
	m_EthCardCtrl[i].SetWindowText(str);
	}

for (;i<4;i++)
	m_EthCardCtrl[i].EnableWindow(FALSE);
	
return TRUE;  // return TRUE unless you set the focus to a control
	           // EXCEPTION: OCX Property Pages should return FALSE
}

void CEthernetCardSelect::OnOK() 
{
CDialog::OnOK();

UpdateData(TRUE);
}

int CEthernetCardSelect::DoModal() 
{
CDialog::DoModal();

return m_EthCard;
}
