#if !defined(AFX_BCUCONF_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
#define AFX_BCUCONF_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BCUConf_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBCUConf_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CBCUConf_View : public CFormView
{
public:
	CBCUConf_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CBCUConf_View)

// Form Data
public:
	//{{AFX_DATA(CBCUConf_View)
	enum { IDD = IDD_BCUCONF_VIEW };
	CListBox	m_SlotConf;
	CString	m_CrateID;
	CString	m_CrateMAC;
	CString	m_CrateIP;
	CString	m_LocPos;
	CString	m_LocNeg;
	CString	m_TotNeg;
	CString	m_TotPos;
	CString	m_LogicVer;
	CString	m_NiosVer;
	CString	m_BoardSN;
	CString	m_BckBoardSN;
	CString	m_ResetStatus;
	CString	m_FrameCnt;
	CString	m_EnaPosAcc;
	CString	m_DiagRecPtr;
	CString	m_DiagRecLen;
	CString	m_EnaHLCommands;
	CString	m_EnaMasterDiag;
	CString	m_RemoteMAC;
	CString	m_RemoteIP;
	CString	m_RemoteUDP;
	CString	m_WRDiagPtr;
	CString	m_RDDiagPtr;
	//}}AFX_DATA

// Attributes
public:
	CFont    m_Font;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBCUConf_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CBCUConf_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CBCUConf_View)
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateProgress(na_bcu_nios_fixed_area_struct *p_bcufixarea,LPARAM dummy2);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BCUCONF_VIEW_H__E467DDF9_B58F_4488_8777_7BA48EECD899__INCLUDED_)
