#if !defined(AFX_THROUGHPUTTEST_VIEW_H__BF779F7E_F82B_4489_9EA4_07F175E36F1A__INCLUDED_)
#define AFX_THROUGHPUTTEST_VIEW_H__BF779F7E_F82B_4489_9EA4_07F175E36F1A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ThroughputTest.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CThroughputTest_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CThroughputTest_View : public CFormView
{
public:
	CThroughputTest_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CThroughputTest_View)

// Form Data
public:
	//{{AFX_DATA(CThroughputTest_View)
	enum { IDD = IDD_THROUGHPUTTEST_VIEW };
	CProgressCtrl	m_Progress;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_StartAddressCtrl;
	CHexEdit	m_SizeCtrl;
	CEdit	m_NumIterCtrl;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	WORD	m_Size;
	DWORD	m_NumIter;
	CString	m_OutText1;
	CString	m_OutText2;
	CString	m_OutText3;
	CString	m_OutText4;
	CString	m_OutText5;
	CString	m_Text;
	int m_DeviceSel;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CThroughputTest_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CThroughputTest_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CThroughputTest_View)
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateProgress(PROGRESS_PACKET *pUpdateData,LPARAM dummy2);
	afx_msg LRESULT OnSetProgress(UINT range,LPARAM dummy2);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_THROUGHPUTTEST_VIEW_H__BF779F7E_F82B_4489_9EA4_07F175E36F1A__INCLUDED_)
