#if !defined(AFX_WRITEDIAGBUFF_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_)
#define AFX_WRITEDIAGBUFF_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WriteDiagBuff_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CWriteDiagBuff_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CWriteDiagBuff_View : public CFormView
{
public:
	CWriteDiagBuff_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CWriteDiagBuff_View)

// Form Data
public:
	//{{AFX_DATA(CWriteDiagBuff_View)
	enum { IDD = IDD_WRITEDIAGBUFF_VIEW };
	CEdit	m_FileNameCtrl;
	CButton	m_Browse;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_StartAddressCtrl;
	CHexEdit	m_StartCmdCtrl;
	CString	m_FileName;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	DWORD	m_StartCmd;
	BOOL	m_WantReply;
	BOOL	m_MultiplePackets;
	int	m_SendSelection;
	//}}AFX_DATA

// Attributes
public:
	BOOL m_wrsame;

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWriteDiagBuff_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWriteDiagBuff_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CWriteDiagBuff_View)
	afx_msg void OnBrowse();
	afx_msg void OnSendConf();
	afx_msg void OnSendStart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITEDIAGBUFF_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_)
