#if !defined(AFX_WRITEFLASH_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_)
#define AFX_WRITEFLASH_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WriteFlash_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CWriteFlash_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CWriteFlash_View : public CFormView
{
public:
	CWriteFlash_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CWriteFlash_View)

// Form Data
public:
	//{{AFX_DATA(CWriteFlash_View)
	enum { IDD = IDD_WRITEFLASH_VIEW };
	CComboBox	m_BlockCtrl;
	CButton	m_Browse;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CString	m_FileName;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	BOOL	m_WantReply;
	BOOL	m_MultiplePackets;
	int		m_Block;
	//}}AFX_DATA

// Attributes
public:
	CString	m_FileExt;

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWriteFlash_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWriteFlash_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CWriteFlash_View)
	afx_msg void OnBrowse();
	afx_msg void OnSelChangeBlock();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITEFLASH_VIEW_H__BD0282B3_FDC8_4340_A7DD_851DB490EDF2__INCLUDED_)
