#if !defined(AFX_WRITESRAM_VIEW_H__9D0E2C59_5555_43EA_B52E_663FB5F5DF48__INCLUDED_)
#define AFX_WRITESRAM_VIEW_H__9D0E2C59_5555_43EA_B52E_663FB5F5DF48__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WriteSram_View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CWriteSram_View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "HexEdit.h"

class CWriteSram_View : public CFormView
{
public:
	CWriteSram_View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CWriteSram_View)

// Form Data
public:
	//{{AFX_DATA(CWriteSram_View)
	enum { IDD = IDD_WRITESRAM_VIEW };
	CButton	m_Browse;
	CHexEdit	m_FirstDSPCtrl;
	CHexEdit	m_LastDSPCtrl;
	CHexEdit	m_StartAddressCtrl;
	CString	m_FileName;
	BYTE	m_FirstDSP;
	BYTE	m_LastDSP;
	DWORD	m_StartAddress;
	BOOL	m_WantReply;
	BOOL	m_MultiplePackets;
	//}}AFX_DATA

// Attributes
public:
	BOOL m_wrsame;

// Operations
public:
	DWORD CreateBuffer(int **bufferLen,BYTE ***buffer);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWriteSram_View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWriteSram_View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CWriteSram_View)
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITESRAM_VIEW_H__9D0E2C59_5555_43EA_B52E_663FB5F5DF48__INCLUDED_)
