// TestProcedures_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "MyAsyncSocket.h"
#include "TestProcedures_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestProcedures_View

IMPLEMENT_DYNCREATE(CTestProcedures_View, CFormView)

CTestProcedures_View::CTestProcedures_View()
	: CFormView(CTestProcedures_View::IDD)
{
	//{{AFX_DATA_INIT(CTestProcedures_View)
	m_FirstDSP = 0;
	m_SaveOnFile = FALSE;
	m_Step = 10;
	m_Text = _T("");
	//}}AFX_DATA_INIT
}

CTestProcedures_View::~CTestProcedures_View()
{
}
 
void CTestProcedures_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestProcedures_View)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_STEP1, m_Step1Ctrl);
	DDX_Control(pDX, IDC_STEP2, m_Step2Ctrl);
	DDX_Control(pDX, IDC_STEP3, m_Step3Ctrl);
	DDX_Control(pDX, IDC_STEP4, m_Step4Ctrl);
	DDX_Control(pDX, IDC_STEP5, m_Step5Ctrl);
	DDX_Control(pDX, IDC_STEP6, m_Step6Ctrl);
	DDX_Control(pDX, IDC_STEP7, m_Step7Ctrl);
	DDX_Control(pDX, IDC_STEP8, m_Step8Ctrl);
	DDX_Control(pDX, IDC_STEP9, m_Step9Ctrl);
	DDX_Control(pDX, IDC_STEP10, m_Step10Ctrl);
	DDX_Control(pDX, IDC_STEP11, m_Step11Ctrl);
	DDX_Control(pDX, IDC_STEP12, m_Step12Ctrl);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_Check(pDX, IDC_SAVEONFILE, m_SaveOnFile);
	DDX_Radio(pDX, IDC_STEP1, m_Step);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestProcedures_View, CFormView)
	//{{AFX_MSG_MAP(CTestProcedures_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
	ON_MESSAGE(WM_SET_PROGRESS, OnSetProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestProcedures_View diagnostics

#ifdef _DEBUG
void CTestProcedures_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CTestProcedures_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestProcedures_View message handlers

BOOL CTestProcedures_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CTestProcedures_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);

UpdateData(TRUE);
}

LRESULT CTestProcedures_View::OnUpdateProgress(UINT value,LPARAM dummy2)
{
m_Progress.SetPos(value);
return (0);
}

LRESULT CTestProcedures_View::OnSetProgress(UINT range,char *string)
{
UpdateData(TRUE);
if (range==-1)
	{ // reset
	m_Text="";
	m_Progress.SetPos(0);
	}
else
	{ // reset
	m_Text=string;
	m_Progress.SetRange32(0,range);
	m_Progress.SetPos(0);
	}
UpdateData(FALSE);
return (0);
}
