// WrRdSramTest_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WrRdSramTest_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWrRdSramTest_View

IMPLEMENT_DYNCREATE(CWrRdSramTest_View, CFormView)

CWrRdSramTest_View::CWrRdSramTest_View()
	: CFormView(CWrRdSramTest_View::IDD)
{
	//{{AFX_DATA_INIT(CWrRdSramTest_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0x00010000;
	m_Size = 364;
	m_NumIter = 1000000;
	m_FixedBuffer = FALSE;
	m_OutText1 = _T("");
	m_OutText2 = _T("");
	m_OutText3 = _T("");
	m_OutText4 = _T("");
	m_OutText5 = _T("");
	m_OutText6 = _T("");
	m_Text = _T("");
	//}}AFX_DATA_INIT
}

CWrRdSramTest_View::~CWrRdSramTest_View()
{
}

void CWrRdSramTest_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWrRdSramTest_View)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Control(pDX, IDC_AREASIZE, m_SizeCtrl);
	DDX_Control(pDX, IDC_NUMITER, m_NumIterCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_HexText(pDX, IDC_AREASIZE, m_Size);
	DDX_Text(pDX, IDC_NUMITER, m_NumIter);
	DDX_Check(pDX, IDC_FIXEDBUFFER, m_FixedBuffer);
	DDX_Text(pDX, IDC_OUTTEXT1, m_OutText1);
	DDX_Text(pDX, IDC_OUTTEXT2, m_OutText2);
	DDX_Text(pDX, IDC_OUTTEXT3, m_OutText3);
	DDX_Text(pDX, IDC_OUTTEXT5, m_OutText5);
	DDX_Text(pDX, IDC_OUTTEXT4, m_OutText4);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	DDX_Text(pDX, IDC_OUTTEXT6, m_OutText6);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWrRdSramTest_View, CFormView)
	//{{AFX_MSG_MAP(CWrRdSramTest_View)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
	ON_MESSAGE(WM_SET_PROGRESS, OnSetProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWrRdSramTest_View diagnostics

#ifdef _DEBUG
void CWrRdSramTest_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWrRdSramTest_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWrRdSramTest_View message handlers

BOOL CWrRdSramTest_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWrRdSramTest_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
m_SizeCtrl.LimitText(4);
m_NumIterCtrl.LimitText(8);

m_Progress.SetPos(0);
}

LRESULT CWrRdSramTest_View::OnUpdateProgress(PROGRESS_PACKET *pUpdateData,LPARAM dummy2)
{
UpdateData(TRUE);
m_OutText1.Format("%.3e",pUpdateData->numBitSent);
m_OutText2.Format("%02d:%02d:%02d.%03d",pUpdateData->elapsedTime/3600000,(pUpdateData->elapsedTime/60000)-(pUpdateData->elapsedTime/3600000)*60,(pUpdateData->elapsedTime/1000)-(pUpdateData->elapsedTime/60000)*60,pUpdateData->elapsedTime%1000);
m_OutText3.Format("%d",pUpdateData->numPacketLost);
m_OutText4.Format("%d",pUpdateData->numBitsWrong);
m_OutText5.Format("%d",pUpdateData->numCmdReplyFault);
if (pUpdateData->elapsedTime)
	m_OutText6.Format("%5.3f",pUpdateData->numBitSent/(double)pUpdateData->elapsedTime/1000.);
else
	m_OutText6.Format("");
UpdateData(FALSE);
m_Progress.SetPos(pUpdateData->progressCount);
return (0);
}

LRESULT CWrRdSramTest_View::OnSetProgress(UINT range,LPARAM dummy2)
{
UpdateData(TRUE);
if (range==-1)
	{ // reset
	m_Text="";
	m_Progress.SetPos(0);
	}
else
	{ // reset
	m_Text="Write/Read SRAM Test in process...";
	m_Progress.SetRange32(0,range);
	m_Progress.SetPos(0);
	}
UpdateData(FALSE);
return (0);
}
